Running karmic as virtual machine with virtio hard disk outputs I/O errors

Bug #420423 reported by Nikolai Bochev on 2009-08-28
22
This bug affects 3 people
Affects Status Importance Assigned to Milestone
linux (Fedora)
Fix Released
Unknown
linux (Ubuntu)
High
Andy Whitcroft
qemu-kvm (Ubuntu)
High
Dustin Kirkland 

Bug Description

When i try to run Karmic Alpha 4 on a Jaunty machine with KVM, i get the following in the log files all the time :

Aug 28 12:30:30 karmic kernel: [ 296.502337] end_request: I/O error, dev vda, sector 0

This happens only if the hard disk of the virtual machine is with type Virtio ( i.e. /dev/vda ). If i use "IDE DISK" as a device type everything runs flawlessly.

The kernel patch and discussion for this issue is here:

http://patchwork.kernel.org/patch/39589/

Dave Hall (skwashd) wrote :

This looks like a dupe of #432959

Andy Whitcroft (apw) wrote :

Reviewing that patch thread there was no objection to it, but it has not yet hit mainline. Waiting for something more concrete here.

tags: added: regression-potential
Changed in ubuntu:
milestone: none → ubuntu-9.10
affects: ubuntu → linux (Ubuntu)
Changed in linux (Ubuntu):
importance: Undecided → Medium
status: New → Triaged
Andy Whitcroft (apw) on 2009-10-09
Changed in linux (Ubuntu):
assignee: nobody → Andy Whitcroft (apw)
status: Triaged → In Progress
Andy Whitcroft (apw) wrote :

I have forward ported the proposed fix from patchworks in comment #1 and build some kernels for testing. If those of you affected could give these a test and report back here I would be grateful. Note that as this affects barrier code there is some risk, do not use on critical data. Kernels can be found at the URL below:

    http://people.ubuntu.com/~apw/lp420423-karmic/

Dave Hall (skwashd) wrote :

Hi Andy,

Thanks for working on this bug. I have tested the AMD64 kernel under KVM and haven't seen the error messages.

I am not running any production VMs using karmic at this stage, so simulating real load wasn't possible. I did run dd with it dumping 25G to disk and so saw no errors. Before loading the test kernel the errors were frequent every time there disk io.

Cheers

Dave

Nikolai Bochev (n-bochev) wrote :

I will test as soon as possible and see if this kernel fixes things in my case.

Changed in linux (Ubuntu):
importance: Medium → High
Changed in linux (Fedora):
status: Unknown → Fix Released
Changed in qemu-kvm (Ubuntu):
status: New → In Progress
assignee: nobody → Dustin Kirkland (kirkland)
importance: Undecided → High
Dustin Kirkland  (kirkland) wrote :

There's a related bug in qemu-kvm, which I'm about to upload a fix for, affecting virtio and qcow2 disks.

Andy's kernel fix is needed too. I'm testing that now.

:-Dustin

summary: Running karmic as virtual machine with virtio hard disk outputs I/O
- erros
+ errors
Dustin Kirkland  (kirkland) wrote :

Andy-

Brilliant! Works like a champ!

Can we please get this into Karmic ASAP!

:-Dustin

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package qemu-kvm - 0.11.0-0ubuntu2

---------------
qemu-kvm (0.11.0-0ubuntu2) karmic; urgency=low

  * debian/patches/09_qemu-fix-qcow2-backing-file-with-virtio.patch:
    cherry-pick patch from Fedora, fix virtio/qcow2 issues, LP: #420423
  * debian/patches/10_qemu-allow-pulseaudio-to-be-the-default.patch:
    needed to complete the fix for LP: #304649
  * debian/control: improve description of qemu-kvm-extras, LP: #448655

 -- Dustin Kirkland <email address hidden> Sun, 11 Oct 2009 13:16:11 -0500

Changed in qemu-kvm (Ubuntu):
status: In Progress → Fix Released
Andy Whitcroft (apw) wrote :

Proposing for inclusion in the karmic release kernel.

Andy Whitcroft (apw) on 2009-10-13
Changed in linux (Ubuntu):
status: In Progress → Fix Committed
Dave Hall (skwashd) wrote :

Andy thanks for the quick response on this one. Far better than some of the "enterprise" distros are at fixing bug.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package linux - 2.6.31-14.46

---------------
linux (2.6.31-14.46) karmic; urgency=low

  [ Andy Whitcroft ]

  * reinstate armel.mk with no flavours
    - LP: #449637
  * [Upstream] elevator: fix fastfail checks to allow merge of readahead
    requests
    - LP: #444915
  * [Upstream] block: silently error unsupported empty barriers too
    - LP: #420423

  [ John Johansen ]

  * SAUCE: AppArmor: Fix mediation of "deleted" paths
    - LP: #415632

  [ Tim Gardner ]

  * [Config] CONFIG_X86_MCE
    https://lists.ubuntu.com/archives/kernel-team/2009-October/007584.html
  * Revert "appletalk: Fix skb leak when ipddp interface is not loaded,
    CVE-2009-2903" - Use patch from 2.6.31.4 which is slightly different.

  [ Upstream Kernel Changes ]

  * x86: fix csum_ipv6_magic asm memory clobber
  * tty: Avoid dropping ldisc_mutex over hangup tty re-initialization
  * x86: Don't leak 64-bit kernel register values to 32-bit processes
  * tracing: correct module boundaries for ftrace_release
  * ftrace: check for failure for all conversions
  * futex: fix requeue_pi key imbalance
  * futex: Move exit_pi_state() call to release_mm()
  * futex: Nullify robust lists after cleanup
  * futex: Fix locking imbalance
  * NOHZ: update idle state also when NOHZ is inactive
  * ima: ecryptfs fix imbalance message
  * libata: fix incorrect link online check during probe
  * sound: via82xx: move DXS volume controls to PCM interface
  * ASoC: WM8350 capture PGA mutes are inverted
  * KVM: Prevent overflow in KVM_GET_SUPPORTED_CPUID
  * KVM: VMX: flush TLB with INVEPT on cpu migration
  * KVM: fix LAPIC timer period overflow
  * KVM: SVM: Fix tsc offset adjustment when running nested
  * KVM: SVM: Handle tsc in svm_get_msr/svm_set_msr correctly
  * net: Fix wrong sizeof
  * mm: add_to_swap_cache() must not sleep
  * sis5513: fix PIO setup for ATAPI devices
  * PIT fixes to unbreak suspend/resume (bug #14222)
  * IMA: open new file for read
  * ACPI: Clarify resource conflict message
  * ACPI: fix Compaq Evo N800c (Pentium 4m) boot hang regression
  * net: restore tx timestamping for accelerated vlans
  * net: unix: fix sending fds in multiple buffers
  * tun: Return -EINVAL if neither IFF_TUN nor IFF_TAP is set.
  * tcp: fix CONFIG_TCP_MD5SIG + CONFIG_PREEMPT timer BUG()
  * net: Fix sock_wfree() race
  * smsc95xx: fix transmission where ZLP is expected
  * sky2: Set SKY2_HW_RAM_BUFFER in sky2_init
  * appletalk: Fix skb leak when ipddp interface is not loaded
  * ax25: Fix possible oops in ax25_make_new
  * ax25: Fix SIOCAX25GETINFO ioctl
  * sit: fix off-by-one in ipip6_tunnel_get_prl
  * Linux 2.6.31.4
  * drm/i915: Fix FDI M/N setting according with correct color depth
    - LP: #416792

 -- Andy Whitcroft <email address hidden> Tue, 13 Oct 2009 12:06:59 +0100

Changed in linux (Ubuntu):
status: Fix Committed → Fix Released
tags: added: iso-testing
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.